﻿Public Class Form1

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'TODO: esta línea de código carga datos en la tabla 'DsTelefonos.telefonos' Puede moverla o quitarla según sea necesario.
    Me.TelefonosTableAdapter.Fill(Me.DsTelefonos.telefonos)
    MostrarPosicion()
  End Sub

  Private Sub MostrarPosicion()
    'Total registros
    Dim iTotal As Integer = TelefonosBindingSource.Count
    'Número (1, 2, ...) de registro
    Dim iPos As Integer
    If iTotal = 0 Then
      etPosicion.Text = "No registros"
    Else
      iPos = TelefonosBindingSource.Position + 1
      'Mostrar información en la etiqueta
      etPosicion.Text = iPos.ToString & " de " & iTotal.ToString
    End If
  End Sub

  Private Sub btPrimero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btPrimero.Click
    TelefonosBindingSource.Position = 0
    MostrarPosicion()
  End Sub

  Private Sub btAnterior_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btAnterior.Click
    TelefonosBindingSource.Position -= 1
    MostrarPosicion()
  End Sub

  Private Sub btSiguiente_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSiguiente.Click
    TelefonosBindingSource.Position += 1
    MostrarPosicion()
  End Sub

  Private Sub btUltimo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btUltimo.Click
    TelefonosBindingSource.Position = TelefonosBindingSource.Count - 1
    MostrarPosicion()
  End Sub

  Private Sub btAñadir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btAñadir.Click
    Dim miTabla As DataTable = DsTelefonos.telefonos
    Dim cfilas As DataRowCollection = miTabla.Rows
    Dim nuevaFila As DataRow
    Try
      'Nueva fila
      nuevaFila = miTabla.NewRow()

      ' Datos por omisión para las columnas de la nueva fila
      nuevaFila(0) = "Nombre"        'columna 0
      nuevaFila(1) = "Dirección"     'columna 1
      nuevaFila(2) = "Teléfono"      'columna 2
      nuevaFila(3) = "Observaciones" 'columna 3
      cfilas.Add(nuevaFila)
      btUltimo.PerformClick() 'hacer clic en Último
      MostrarPosicion()
      ctNombre.Focus() 'enfocar la caja de texto ctNombre
    Catch ex As System.Data.ConstraintException
      'Capturar posible error por clave duplicada (teléfono)
      MessageBox.Show(ex.Message)
    End Try
  End Sub

  Private Sub btBorrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btBorrar.Click
    Dim vistaFilaActual As DataRowView
    Dim NL As String = Environment.NewLine

    If (MessageBox.Show("¿Desea borrar este registro?" & NL, _
        "Buscar", MessageBoxButtons.YesNo, _
        MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes) Then
      vistaFilaActual = TelefonosBindingSource.Current
      vistaFilaActual.Row.Delete()
      MostrarPosicion()
    End If
  End Sub

  Private Sub btBuscar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btBuscar.Click
    Dim miTabla As DataTable = DsTelefonos.telefonos
    Dim cfilas As DataRowCollection = miTabla.Rows
    Dim filaBuscada() As DataRow 'matriz de filas
    Dim NL As String = Environment.NewLine
    'Buscar en la columna Nombre de cada fila
    Dim criterio As String = "Nombre Like '*" & ctBuscar.Text & "*'"

    'Utilizar el método Select para encontrar todas las filas que
    'pasen el filtro y almacenarlas en la matriz filaBuscada
    filaBuscada = miTabla.Select(criterio)
    If (filaBuscada.GetUpperBound(0) = -1) Then
      MessageBox.Show("No se encontraron registros coincidentes", "Buscar")
      Exit Sub
    End If

    'Seleccionar de las filas encontradas la que buscamos
    Dim i, j As Integer
    For i = 0 To filaBuscada.GetUpperBound(0)
      If (MessageBox.Show("¿Es este el nombre buscado?" & NL & _
          filaBuscada(i)(0) & NL, "Buscar", _
          MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes) Then
        'Si: mostrar en el formulario la fila seleccionada
        For j = 0 To cfilas.Count - 1
          If (cfilas(j).Equals(filaBuscada(i))) Then
            TelefonosBindingSource.Position = j
            MostrarPosicion()
          End If
        Next j
        Exit For
      End If
    Next i
  End Sub

  Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    If (DsTelefonos.HasChanges()) Then
      Me.TelefonosTableAdapter.Update(Me.DsTelefonos.telefonos)
      MessageBox.Show("Origen de datos actualizado")
    End If
  End Sub
End Class
